<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

mysqli_begin_transaction($conn);

if (isset($_POST["AddNew_SI"])) 
{
    try
    {
        $keys = [
            "drsi_date",
            "drsi_customer_name",
            "drsi_effectivity_date",
			"drsi_number",
			"drsi_eggtray",
			"drsi_jmb_trays",
            "drsi_xlr_trays",
            "drsi_lrg_trays",
            "drsi_med_trays",
            "drsi_sml_trays",
            "drsi_pul_trays",
            "drsi_pwe_trays",
            "drsi_spw_trays",
            "drsi_b1_trays",
            "drsi_b2_trays",
            "drsi_b3_trays",
            "drsi_dirty_trays"
        ];
        $data = getDataFromPost($keys, $_POST);
		
        $checkQuery = "SELECT * FROM sales_invoice WHERE si_number = ?";
        $checkResult = executeQuery($conn, $checkQuery, "s", [$data["drsi_number"]]);

		if ($checkResult === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		} 

		if ($checkResult->num_rows > 0) { 
            ?>
			<script>
				alert( "This Sales Invoice is already in our system." );
			</script>
			<?php
			exit();
        }

        $result = executeQuery($conn, "INSERT INTO sales_invoice (addedby_user,si_date,si_customer_name,si_price_effectivity,si_number,si_eggtray_pcs,si_jmb_trays,si_xlr_trays,si_lrg_trays,si_med_trays,si_sml_trays,si_pul_trays,si_pwe_trays,si_spw_trays,si_b1_trays,si_b2_trays,si_b3_trays,si_dirty_trays) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", "sssssiiiiiiiiiiiii", [$userName, $data["drsi_date"], $data["drsi_customer_name"], $data["drsi_effectivity_date"], $data["drsi_number"], $data["drsi_eggtray"], $data["drsi_jmb_trays"], $data["drsi_xlr_trays"], $data["drsi_lrg_trays"], $data["drsi_med_trays"], $data["drsi_sml_trays"], $data["drsi_pul_trays"], $data["drsi_pwe_trays"], $data["drsi_spw_trays"], $data["drsi_b1_trays"], $data["drsi_b2_trays"], $data["drsi_b3_trays"], $data["drsi_dirty_trays"]]);
        
		if ($result === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		} 
    
        mysqli_commit($conn);
		
		header("Location: " . $_SERVER["REQUEST_URI"]);
		exit();
    }
    catch (Exception $e) 
    {
        mysqli_rollback($conn);
		// Log the error message
        error_log($e->getMessage());
		// Redirect to an error page or display an error message
        //header("Location: error_page.php");
        //exit();
    }
}

if (isset($_POST["Update_SI"])) 
{
    try
    {
        $keys = [
            "drsi_date",
            "drsi_customer_name",
            "drsi_effectivity_date",
			"drsi_number",
			"drsi_eggtray",
			"drsi_jmb_trays",
            "drsi_xlr_trays",
            "drsi_lrg_trays",
            "drsi_med_trays",
            "drsi_sml_trays",
            "drsi_pul_trays",
            "drsi_pwe_trays",
            "drsi_spw_trays",
            "drsi_b1_trays",
            "drsi_b2_trays",
            "drsi_b3_trays",
            "drsi_dirty_trays"
        ];
        $data = getDataFromPost($keys, $_POST);
		$result = executeQuery($conn, "SELECT * FROM sales_invoice WHERE id = ?", "s", [$_POST["drsi_id"]]);
		
		if ($result === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		}
		
		if ($result->num_rows > 0)
		{
			$currentRecord = $result->fetch_assoc();
            $id = $currentRecord["id"];
			$currentVersion = $currentRecord["version"];
			
			// Mark the current version as outdated
            $updateOldVersionQuery = "UPDATE sales_invoice SET is_current = FALSE WHERE id = ? AND is_current = TRUE";
            $updateOldVersionResult = executeQuery($conn, $updateOldVersionQuery, "i", [$id]);
			
			if ($updateOldVersionResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			}
			
			// Insert the new version
            $newVersion = $currentVersion + 1;
            $insertNewVersionQuery = "INSERT INTO sales_invoice (addedby_user,si_date,si_customer_name,si_price_effectivity,si_number,si_eggtray_pcs,si_jmb_trays,si_xlr_trays,si_lrg_trays,si_med_trays,si_sml_trays,si_pul_trays,si_pwe_trays,si_spw_trays,si_b1_trays,si_b2_trays,si_b3_trays,si_dirty_trays,version,is_current) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,? ,? ,? ,? ,? , ?, TRUE)";
            $updateResult = executeQuery($conn, $insertNewVersionQuery, "sssssiiiiiiiiiiiiii", [$userName, $data["drsi_date"], $data["drsi_customer_name"], $data["drsi_effectivity_date"], $data["drsi_number"], $data["drsi_eggtray"], $data["drsi_jmb_trays"], $data["drsi_xlr_trays"], $data["drsi_lrg_trays"], $data["drsi_med_trays"], $data["drsi_sml_trays"], $data["drsi_pul_trays"], $data["drsi_pwe_trays"], $data["drsi_spw_trays"], $data["drsi_b1_trays"], $data["drsi_b2_trays"], $data["drsi_b3_trays"], $data["drsi_dirty_trays"], $newVersion]);
			
			if ($updateResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			} 
			
			mysqli_commit($conn);

			header("Location: " . $_SERVER["REQUEST_URI"]);
			exit();
		}
    } catch (Exception $e) {
        mysqli_rollback($conn);
        // Log the error message
        error_log($e->getMessage());
        // Redirect to an error page or display an error message
        //echo "Error: " . $e->getMessage();
        // header("Location: error_page.php");
        // exit();
    }
}
?>