<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

$updateSuccess = false;

mysqli_begin_transaction($conn);

if (isset($_POST["fcUpdate"]) && isset($_POST["fc_id"]) && !empty($_POST["fc_id"])) {
	try {
		$keys = [
		"fc_BatchName", 
		"fc_BldgNo",
		"fc_FCode"
		];
		
		$data = getDataFromPost($keys, $_POST);	
		$result = executeQuery($conn, "SELECT * FROM fcode WHERE id = ? AND is_current = TRUE", "s", [$_POST["fc_id"]]);
		
		if ($result === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		} 
		
		if ($result->num_rows > 0) {
			$currentRecord = $result->fetch_assoc();
            $id = $currentRecord["id"];
            $currentVersion = $currentRecord["version"];
			
			// Mark the current version as outdated
            $updateOldVersionQuery = "UPDATE fcode SET is_current = FALSE WHERE id = ? AND is_current = TRUE";
            $updateOldVersionResult = executeQuery($conn, $updateOldVersionQuery, "i", [$id]);
			
			if ($updateOldVersionResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			}
			
			// Insert the new version
            $newVersion = $currentVersion + 1;
            $insertNewVersionQuery = "INSERT INTO fcode (addedby_user,BatchName,BldgNo,FCode,version,is_current) VALUES (?, ?, ?, ?, ?, TRUE)";
            $updateResult = executeQuery($conn, $insertNewVersionQuery, "ssssi", [$userName, $data["fc_BatchName"], $data["fc_BldgNo"], $data["fc_FCode"], $newVersion]);
			
			if ($updateResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			} else {
				$updateSuccess = true;
			}

			mysqli_commit($conn);

			if ($updateSuccess) {
				$_SESSION["updateSuccess"] = true;

				header("Location: " . $_SERVER["REQUEST_URI"]);
				exit();
			}
		}
	} catch (Exception $e) {
        mysqli_rollback($conn);
		// Log the error message
        error_log($e->getMessage());
		// Redirect to an error page or display an error message
        //header("Location: error_page.php");
        //exit();
    }
}

if (isset($_POST["bdepUpdate"]) && isset($_POST["bdep_id"]) && !empty($_POST["bdep_id"])) {
	try {
		$keys = [
		"bdep_BatchCode", 
		"bdep_BatchName", 
		"bdep_BldgNo",
		"bdep_CheckInDate", 
		"bdep_Breed", 
		"bdep_HenHoused", 
		"bdep_Prod_Previous", 
		"bdep_Status"
		];
		
		$data = getDataFromPost($keys, $_POST);	
		$result = executeQuery($conn, "SELECT * FROM epr_batch_details WHERE id = ? AND is_current = TRUE", "s", [$_POST["bdep_id"]]);
		
		if ($result === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		} 
		
		if ($result->num_rows > 0)
		{
			$currentRecord = $result->fetch_assoc();
            $id = $currentRecord["id"];
            $currentVersion = $currentRecord["version"];
			
			// Mark the current version as outdated
            $updateOldVersionQuery = "UPDATE epr_batch_details SET Status = FALSE, is_current = FALSE WHERE id = ? AND is_current = TRUE";
            $updateOldVersionResult = executeQuery($conn, $updateOldVersionQuery, "i", [$id]);
			
			if ($updateOldVersionResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			}
			
			// Insert the new version
            $newVersion = $currentVersion + 1;
            //$insertNewVersionQuery = "INSERT INTO epr_batch_details (addedby_user,BatchCode,BatchName,BldgNo,CheckInDate,Breed,HenHoused,Prod_Current,Prod_Previous,Age,S_H_H,Status,version,is_current) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, TRUE)";
			$insertNewVersionQuery = "INSERT INTO epr_batch_details (addedby_user,BatchCode,BatchName,BldgNo,CheckInDate,Breed,HenHoused,Prod_Previous,Status,version,is_current) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, TRUE)";
            $updateResult = executeQuery($conn, $insertNewVersionQuery, "sssssssssi", [$userName, $data["bdep_BatchCode"], $data["bdep_BatchName"], $data["bdep_BldgNo"], $data["bdep_CheckInDate"], $data["bdep_Breed"], $data["bdep_HenHoused"], $data["bdep_Prod_Previous"], $data["bdep_Status"], $newVersion]);
			
			if ($updateResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			} else {
				$updateSuccess = true;
			}

			mysqli_commit($conn);

			if ($updateSuccess) {
				$_SESSION["updateSuccess"] = true;
				header("Location: " . $_SERVER["REQUEST_URI"]);
				exit();
			}
		}
	} catch (Exception $e) {
        mysqli_rollback($conn);
        // Log the error message
        error_log($e->getMessage());
		// Redirect to an error page or display an error message
        //header("Location: error_page.php");
        //exit();
    }
}

if (isset($_POST["bdesUpdate"]) && isset($_POST["bdes_id"]) && !empty($_POST["bdes_id"]))
{
	try
	{
		$keys = [
		"bdes_BatchCode", 
		"bdes_BatchName", 
		"bdes_CheckInDate", 
		"bdes_Breed",
		"bdes_prev_JMB",
		"bdes_prev_XLR",
		"bdes_prev_LRG",
		"bdes_prev_MED",
		"bdes_prev_SML",
		"bdes_prev_PUL",
		"bdes_prev_PWE",
		"bdes_prev_SPW",
		"bdes_prev_B1",
		"bdes_prev_B2",
		"bdes_prev_B3",
		"bdes_prev_M_Dirty",
		"bdes_prev_B_Dirty",
		"bdes_Status"
		];
		
		$data = getDataFromPost($keys, $_POST);	
		$result = executeQuery($conn, "SELECT * FROM esr_batch_details WHERE id = ? AND is_current = TRUE", "s", [$_POST["bdes_id"]]);
		
		if ($result === false) { 
			throw new Exception("Error executing query: " . $conn->error);
		} 		
		
		if ($result->num_rows > 0)
		{
			$currentRecord = $result->fetch_assoc();
            $id = $currentRecord["id"];
            $currentVersion = $currentRecord["version"];
			
			// Mark the current version as outdated
            $updateOldVersionQuery = "UPDATE esr_batch_details SET is_current = FALSE WHERE id = ? AND is_current = TRUE";
            $updateOldVersionResult = executeQuery($conn, $updateOldVersionQuery, "i", [$id]);
			
			if ($updateOldVersionResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			}
				
			// Insert the new version
            $newVersion = $currentVersion + 1;
            $insertNewVersionQuery = "INSERT INTO esr_batch_details (addedby_user,BatchCode,BatchName,CheckInDate,Breed,prev_JMB,prev_XLR,prev_LRG,prev_MED,prev_SML,prev_PUL,prev_PWE,prev_SPW,prev_B1,prev_B2,prev_B3,prev_M_Dirty,prev_B_Dirty,Status,version,is_current) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,TRUE)";
            $updateResult = executeQuery($conn, $insertNewVersionQuery, "sssssssssssssssssssi", [$userName, $data["bdes_BatchCode"], $data["bdes_BatchName"], $data["bdes_CheckInDate"], $data["bdes_Breed"], $data["bdes_prev_JMB"], $data["bdes_prev_XLR"], $data["bdes_prev_LRG"], $data["bdes_prev_MED"], $data["bdes_prev_SML"], $data["bdes_prev_PUL"], $data["bdes_prev_PWE"], $data["bdes_prev_SPW"], $data["bdes_prev_B1"], $data["bdes_prev_B2"], $data["bdes_prev_B3"], $data["bdes_prev_M_Dirty"], $data["bdes_prev_B_Dirty"], $data["bdes_Status"], $newVersion]);
			
			if ($updateResult === false) { 
				throw new Exception("Error executing query: " . $conn->error);
			} else {
				$updateSuccess = true;
			}

			mysqli_commit($conn);

			if ($updateSuccess) 
			{
				$_SESSION["updateSuccess"] = true;

				header("Location: " . $_SERVER["REQUEST_URI"]);
				exit();
			}
		}
	}
	catch (Exception $e) {
        mysqli_rollback($conn);
        // Log the error message
        error_log($e->getMessage());
		// Redirect to an error page or display an error message
        //header("Location: error_page.php");
        //exit();
    }
}

if (isset($_SESSION["updateSuccess"])) 
{
    ?>
    <script>
        $( ".dispMessage" ).append( "<div class='alert alert-primary d-flex align-items-center shadow' role='alert'><h4>Successfully Updated!</h4></div>" );
    </script>
    <?php
    unset($_SESSION["updateSuccess"]);
}
?>