<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

$headers = [
"Batch Code", 
"Batch Name", 
"Bldg No.", 
"Check In Date", 
"Breed Type", 
"Hen Housed", 
"Production", 
"Production", 
"Production", 
"Age In Weeks", 
"S.H.H.",
"Status"
];

echo "<table id='MyTable_controller' class='ui display table controller bdep' style='display: none;'>";
echo "<thead><tr>";
echo "<th colspan='6'></th>
<th class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.9;'>Current</th>
<th class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.7;'>Previous</th>
<th class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.5;'>YTD</th>
<th colspan='3'></th>
</tr>";

echo "<tr>";
foreach ($headers as $index => $headerText) 
{
	if ($index == 6) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.9;'>{$headerText}</th>";
	}
	else if ($index == 7) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.7;'>{$headerText}</th>";
	}
	else if ($index == 8) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.5;'>{$headerText}</th>";
	}
	else
	{
		echo "<th class='bg-dark text-center text-white text-uppercase'>{$headerText}</th>";
	}
}
echo "</tr></thead><tbody>";

$result = executeQuery($conn, "SELECT * FROM epr_batch_details WHERE is_deleted = FALSE AND is_current = TRUE ORDER BY Status, CheckInDate");

if ($result === false) { 
	throw new Exception("Error executing query: " . $conn->error);
} 

while ($row = mysqli_fetch_assoc($result)) 
{
    echo "<tr class='bdep-clickable-row' data-id='". $row["id"] . "'>";
	echo "<td class='align-baseline'>".$row["BatchCode"]."</td>";
	echo "<td class='align-baseline'><span class='bolded-text'>".$row["BatchName"]."</span></td>";
	
	$bldgNo = $row["BldgNo"];
    
    if (!empty($bldgNo)) {
        // Split the string by comma
        $items = explode(",", $bldgNo); // Split by comma only
        
        // Initialize an array to hold the formatted strings
        $formattedItems = [];

        foreach ($items as $item) {
            // Trim any extra spaces
            $item = trim($item);
            // Split each item by the '[' character to separate the label and value
            $parts = explode("[", $item);
            $label = $parts[0];
            $value = rtrim($parts[1], "]"); // Remove the closing bracket
            $formattedItems[] = "<span class='bg-warning rounded text-dark px-1'>$label</span><span class='bg-dark rounded text-white px-1'>$value</span>";
        }

        // Join the formatted items with a <br> tag for display in separate lines
        $output = implode("<br>", $formattedItems);
    } else {
        $output = ""; // Handle null or blank BldgNo
    }
    
    echo "<td class=''>$output</td>";
	
	echo "<td class='align-baseline'>".$row["CheckInDate"]."</td>";
	echo "<td class='align-baseline'>".$row["Breed"]."</td>";
	echo "<td class='align-baseline'>".number_format($row["HenHoused"])."</td>";

	$rrquery = "SELECT COALESCE(SUM(H_TOTAL), 0) as Prod_Current FROM input_production WHERE BatchName = ?";
	$rresult = executeQuery($conn, $rrquery, "s", [$row["BatchName"]]);
	
	if ($rresult === false) { 
		throw new Exception("Error executing query: " . $conn->error);
	}
	
	$rrow = mysqli_fetch_assoc($rresult);
	
	echo "<td class='bg-dark text-white align-baseline' style='--bs-bg-opacity:.9;'>".number_format($rrow["Prod_Current"])."</td>";
	echo "<td class='bg-dark text-white align-baseline' style='--bs-bg-opacity:.7;'>".number_format($row["Prod_Previous"])."</td>";

	$Prod_YTD = $rrow["Prod_Current"] + $row["Prod_Previous"];
	echo "<td class='bg-dark text-white align-baseline' style='--bs-bg-opacity:.5;'>".number_format($Prod_YTD)."</td>";
	
	$AgeInWeeks = floor((strtotime(date("Y-m-d")) - strtotime($row["CheckInDate"])) / (7 * 24 * 60 * 60));
	
	echo "<td class='align-baseline'>".$AgeInWeeks."</td>";
	
	$shhquery = "SELECT Stnd_H_H_per FROM controller_standards WHERE is_current = TRUE AND BreedType = ? AND AgeInWeeks = ?";
	$shhresult = executeQuery($conn, $shhquery, "ss", [$row["Breed"],$AgeInWeeks]);
	
	if ($shhresult === false) { 
		throw new Exception("Error executing query: " . $conn->error);
	}
	
	$shhrow = ($shhresult && mysqli_num_rows($shhresult) > 0) ? mysqli_fetch_assoc($shhresult) : null;
	$stdHH = $shhrow["Stnd_H_H_per"] ?? 0;
	
	echo "<td class='align-baseline'>".$stdHH."</td>";
	
	$Status = "Inactive";
	if ( $row["Status"] == 0 ) 
	{
		$Status = "<span class='bg-danger rounded text-white px-1'>Inactive</span>";
	}
	else
	{
		$Status = "<span class='bg-success rounded text-white px-1'>Active</span>";
	}
	echo "<td class='align-baseline'>".$Status."</td>";
	echo "</tr>";
}
echo "</tbody></table>";
?>