<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

$headers = [
"Batch Code", 
"Batch Name", 
"Check In Date", 
"Breed Type", 
"JMB", 
"XLR", 
"LRG", 
"MED", 
"SML", 
"PUL", 
"PWE", 
"SPW", 
"B1", 
"B2", 
"B3", 
"M.Dirty", 
"B.Dirty",
"JMB", 
"XLR", 
"LRG", 
"MED", 
"SML", 
"PUL", 
"PWE", 
"SPW", 
"B1", 
"B2", 
"B3", 
"M.Dirty", 
"B.Dirty",
"JMB", 
"XLR", 
"LRG", 
"MED", 
"SML", 
"PUL", 
"PWE", 
"SPW", 
"B1", 
"B2", 
"B3", 
"M.Dirty", 
"B.Dirty", 
"TOTAL", 
"A.W.C",
"Status"
];

echo "<table id='MyTable_controller' class='ui display table controller bdes' style='display: none;'>";
echo "<thead><tr>";
echo "<th colspan='4'></th>
<th colspan='13' class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.9;'>Current</th>
<th colspan='13' class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.7;'>Previous</th>
<th colspan='13' class='bg-dark text-center text-white text-uppercase border-bottom-0' style='--bs-bg-opacity:.5;'>YTD</th>
<th colspan='3'></th>
</tr>";

echo "<tr>";
foreach ($headers as $index => $headerText) 
{
	if ($index >= 4 && $index <= 16) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.9;'>{$headerText}</th>";
	}
	else if ($index >= 17 && $index <= 29) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.7;'>{$headerText}</th>";
	}
	else if ($index >= 30 && $index <= 42) 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase border-top-0' style='--bs-bg-opacity:.5;'>{$headerText}</th>";
	}
	else 
	{
		echo "<th class='bg-dark text-center text-white text-uppercase'>{$headerText}</th>";
	}
}
echo "</tr></thead><tbody>";

$result = executeQuery($conn, "SELECT * FROM esr_batch_details WHERE is_deleted = FALSE AND is_current = TRUE ORDER BY Status, CheckInDate");

if ($result === false) { 
	throw new Exception("Error executing query: " . $conn->error);
} 

while ($row = mysqli_fetch_assoc($result)) 
{
    echo "<tr class='bdes-clickable-row' data-id='". $row["id"] . "'>";
	echo "<td>".$row["BatchCode"]."</td>";
	echo "<td class='align-baseline'><span class='bolded-text'>". $row["BatchName"] . "</span></td>";
	echo "<td>".$row["CheckInDate"]."</td>";
	echo "<td>".$row["Breed"]."</td>";
	
	$rrquery = "SELECT 
    COALESCE(SUM(JMB), 0) as cur_JMB,
    COALESCE(SUM(XLR), 0) as cur_XLR,
    COALESCE(SUM(LRG), 0) as cur_LRG,
    COALESCE(SUM(MED), 0) as cur_MED,
    COALESCE(SUM(SML), 0) as cur_SML,
    COALESCE(SUM(PUL), 0) as cur_PUL,
    COALESCE(SUM(PWE), 0) as cur_PWE,
    COALESCE(SUM(SPW), 0) as cur_SPW,
    COALESCE(SUM(B1), 0) as cur_B1,
    COALESCE(SUM(B2), 0) as cur_B2,
    COALESCE(SUM(B3), 0) as cur_B3,
    COALESCE(SUM(M_Dirty), 0) as cur_M_Dirty,
	COALESCE(SUM(B_Dirty), 0) as cur_B_Dirty
FROM egg_weight
WHERE BatchName = ?";
	$rresult = executeQuery($conn, $rrquery, "s", [$row["BatchName"]]);
	
	if ($rresult === false) { 
		throw new Exception("Error executing query: " . $conn->error);
	} 
	
	$rrow = mysqli_fetch_assoc($rresult);
	
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_JMB"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_XLR"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_LRG"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_MED"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_SML"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_PUL"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_PWE"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_SPW"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_B1"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_B2"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_B3"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_M_Dirty"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.9;'>".$rrow["cur_B_Dirty"]."</td>";
	
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_JMB"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_XLR"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_LRG"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_MED"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_SML"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_PUL"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_PWE"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_SPW"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_B1"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_B2"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_B3"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_M_Dirty"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.7;'>".$row["prev_B_Dirty"]."</td>";
	
	$ytdQuery = "SELECT 
	COALESCE(SUM({$rrow['cur_JMB']} + prev_JMB), 0) as ytd_JMB,
    COALESCE(SUM({$rrow['cur_XLR']} + prev_XLR), 0) as ytd_XLR,
    COALESCE(SUM({$rrow['cur_LRG']} + prev_LRG), 0) as ytd_LRG,
    COALESCE(SUM({$rrow['cur_MED']} + prev_MED), 0) as ytd_MED,
    COALESCE(SUM({$rrow['cur_SML']} + prev_SML), 0) as ytd_SML,
    COALESCE(SUM({$rrow['cur_PUL']} + prev_PUL), 0) as ytd_PUL,
    COALESCE(SUM({$rrow['cur_PWE']} + prev_PWE), 0) as ytd_PWE,
    COALESCE(SUM({$rrow['cur_SPW']} + prev_SPW), 0) as ytd_SPW,
    COALESCE(SUM({$rrow['cur_B1']} + prev_B1), 0) as ytd_B1,
    COALESCE(SUM({$rrow['cur_B2']} + prev_B2), 0) as ytd_B2,
    COALESCE(SUM({$rrow['cur_B3']} + prev_B3), 0) as ytd_B3,
    COALESCE(SUM({$rrow['cur_M_Dirty']} + prev_M_Dirty), 0) as ytd_M_Dirty,
	COALESCE(SUM({$rrow['cur_B_Dirty']} + prev_B_Dirty), 0) as ytd_B_Dirty
FROM esr_batch_details
WHERE is_current = TRUE AND BatchName = ?";
	$ytdResult = executeQuery($conn, $ytdQuery, "s", [$row['BatchName']]);
	
	if ($ytdResult === false) { 
		throw new Exception("Error executing query: " . $conn->error);
	} 
	
	$ytdRow = mysqli_fetch_assoc($ytdResult);
	
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_JMB"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_XLR"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_LRG"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_MED"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_SML"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_PUL"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_PWE"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_SPW"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_B1"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_B2"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_B3"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_M_Dirty"]."</td>";
	echo "<td class='bg-dark text-white' style='--bs-bg-opacity:.5;'>".$ytdRow["ytd_B_Dirty"]."</td>";
	
	$TOTAL = 0;
	foreach ($ytdRow as $columnTotal) 
	{
		$TOTAL += $columnTotal;
	}
	echo "<td><span class='bg-warning rounded text-dark px-1'>" . $TOTAL . "</span></td>";
	
	//89.5	 75.14 	 67.89 	 63.45 	 59.55 	 55.68 	 51.85 	 49.86 
	
	if ($TOTAL != 0) 
	{
		$AWC = number_format((($ytdRow["ytd_JMB"] * 89.5) + ($ytdRow["ytd_XLR"] * 75.14) + ($ytdRow["ytd_LRG"] * 67.89) + ($ytdRow["ytd_MED"] * 63.45) + ($ytdRow["ytd_SML"] * 59.55 ) + ($ytdRow["ytd_PUL"] * 55.68) +( $ytdRow["ytd_PWE"] * 51.85) + ($ytdRow["ytd_SPW"] * 49.86))/$TOTAL, 2);
	}
	else 
	{
		$AWC = 0;
	}
	
	echo "<td><span class='bg-info rounded text-dark px-1'>" . $AWC . "</span></td>";
	
	$Status = "Inactive";
	if ( $row['Status'] == 0 ) 
	{
		$Status = "<span class='bg-danger rounded text-white px-1'>Inactive</span>";
	}
	else
	{
		$Status = "<span class='bg-success rounded text-white px-1'>Active</span>";
	}
	echo "<td>" . $Status . "</td>";
	
	echo "</tr>";
}
echo "</tbody></table>";
?>