<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

$updateSuccess = false;
$rcode = [];

foreach ($_POST as $key => $value) 
{
	if (preg_match('/^id_(\d+)$/', $key, $matches)) 
	{
		$index = intval($matches[1]);
		$rcode[] = $index;
	}
}

mysqli_begin_transaction($conn);

if (isset($_POST["SaveButton"]) && isset($_GET["p"]) && $_GET["p"] == "cs") 
{
    try
    {
        for ($i = 0; $i < count($rcode); $i++) 
        {
			$keys = [
				"BreedType_$rcode[$i]", 
				"AgeInWeeks_$rcode[$i]", 
				"Stnd_H_D_per_$rcode[$i]", 
				"Stnd_H_H_per_$rcode[$i]", 
				"EggWeight_g_$rcode[$i]", 
				"EggWeight_Weeks_$rcode[$i]", 
				"EggWeight_Cum_$rcode[$i]", 
				"EggMass_Weeks_$rcode[$i]", 
				"EggMass_Cum_$rcode[$i]",
				"id_$rcode[$i]"
			];
			
            $data = getDataFromPost($keys, $_POST); 
            $originalData = fetchOriginalData($conn, $data["id_$rcode[$i]"]);

            if (hasChanges($originalData, $data)) 
			{
				$query = "UPDATE controller_standards SET addedby_user=?,BreedType=?,AgeInWeeks=?,Stnd_H_D_per=?,Stnd_H_H_per=?,EggWeight_g=?,EggWeight_Weeks=?,EggWeight_Cum=?,EggMass_Weeks=?,EggMass_Cum=? WHERE id = ?";
                $result = executeQuery($conn, $query, "ssssssssssi", [$userName, $data["BreedType_$rcode[$i]"], $data["AgeInWeeks_$rcode[$i]"], $data["Stnd_H_D_per_$rcode[$i]"], $data["Stnd_H_H_per_$rcode[$i]"], $data["EggWeight_g_$rcode[$i]"], $data["EggWeight_Weeks_$rcode[$i]"], $data["EggWeight_Cum_$rcode[$i]"], $data["EggMass_Weeks_$rcode[$i]"], $data["EggMass_Cum_$rcode[$i]"], $data["id_$rcode[$i]"]]);
                
				if ($result === false) { 
					throw new Exception("Error executing query: " . $conn->error);
				}  else {
                    $updateSuccess = true;
                }
            }
        }
        mysqli_commit($conn);
        
        if ($updateSuccess) 
        {
            $_SESSION["update_success"] = true;
            
            header("Location: " . $_SERVER["REQUEST_URI"]);
            exit();
        }
    } 
    catch (Exception $e) 
    {
        mysqli_rollback($conn);
		// Log the error message
        error_log($e->getMessage());
		// Redirect to an error page or display an error message
        //header("Location: error_page.php");
        //exit();
    }
}

if (isset($_SESSION["update_success"])) 
{
    ?>
    <script>
        $( ".dispMessage" ).append( "<div class='alert alert-primary d-flex align-items-center shadow' role='alert'><h4>Saved!</h4></div>" );
    </script>
    <?php
    unset($_SESSION["update_success"]);
}
?>