<?php
require_once("dbconn.php");
require_once("phpFunctions.php");

$data_id = isset($_GET["data_id"]) ? $_GET["data_id"] : null;

$result = executeQuery($conn, "SELECT * FROM sales_invoice WHERE id = ?", "i", [$data_id]);

if ($result === false) { 
	throw new Exception("Error executing query: " . $conn->error);
} 

if ($result->num_rows > 0) {
	while($row = $result->fetch_assoc()) 
	{
		$response["si_id"] = $row["id"];
		$response["si_date"] = $row["si_date"];
		$response["si_customer_name"] = $row["si_customer_name"];
		$response["si_price_effectivity"] = $row["si_price_effectivity"];
		$response["si_number"] = $row["si_number"];
		$response["si_eggtray"] = isset($row["si_eggtray_pcs"]) && $row["si_eggtray_pcs"] !== 0 ? $row["si_eggtray_pcs"] : "";
		$response["si_jmb_trays"] = isset($row["si_jmb_trays"]) && $row["si_jmb_trays"] !== 0 ? $row["si_jmb_trays"] : "";
		$response["si_xlr_trays"] = isset($row["si_xlr_trays"]) && $row["si_xlr_trays"] !== 0 ? $row["si_xlr_trays"] : "";
		$response["si_lrg_trays"] = isset($row["si_lrg_trays"]) && $row["si_lrg_trays"] !== 0 ? $row["si_lrg_trays"] : "";
		$response["si_med_trays"] = isset($row["si_med_trays"]) && $row["si_med_trays"] !== 0 ? $row["si_med_trays"] : "";
		$response["si_sml_trays"] = isset($row["si_sml_trays"]) && $row["si_sml_trays"] !== 0 ? $row["si_sml_trays"] : "";
		$response["si_pul_trays"] = isset($row["si_pul_trays"]) && $row["si_pul_trays"] !== 0 ? $row["si_pul_trays"] : "";
		$response["si_pwe_trays"] = isset($row["si_pwe_trays"]) && $row["si_pwe_trays"] !== 0 ? $row["si_pwe_trays"] : "";
		$response["si_spw_trays"] = isset($row["si_spw_trays"]) && $row["si_spw_trays"] !== 0 ? $row["si_spw_trays"] : "";
		$response["si_b1_trays"] = isset($row["si_b1_trays"]) && $row["si_b1_trays"] !== 0 ? $row["si_b1_trays"] : "";
		$response["si_b2_trays"] = isset($row["si_b2_trays"]) && $row["si_b2_trays"] !== 0 ? $row["si_b2_trays"] : "";
		$response["si_b3_trays"] = isset($row["si_b3_trays"]) && $row["si_b3_trays"] !== 0 ? $row["si_b3_trays"] : "";
		$response["si_dirty_trays"] = isset($row["si_dirty_trays"]) && $row["si_dirty_trays"] !== 0 ? $row["si_dirty_trays"] : "";
	}
} 

if (empty($response)) {
	echo json_encode(["status" => "error", "message" => "ipRowData - An error occurred while processing your request."]);
} else {
    echo json_encode($response);
}
?>